
//***********************
// TLC Layer Mover/Copier
// by d.e.boyce
// excuse bad programming
//***********************

//This is the source code for the MCLAYER.EXE utility program. It is included
//as an example of how to write simple programs that work with LASI cells
//in TLC format. Most of the functions are generic and may be used in other programs.

// Compile with Microsoft Visual C/C++ 5.0 or 6.0 as Windows Console application. 

//IMPORTANT the function strtok (used to read records) is not recursive.
//You will get strange bugs if you use it recursively.


typedef unsigned char uchar;
typedef unsigned int uint;
typedef unsigned long ulong;


#define VERS   "6.1.4.0"
#define VERSX   "6.1.4.0"
#define NAMLEN 32
#define NAMBUF (NAMLEN+1)

#define TLCLIM  100
#define VTXMAX  512
#define CELMAX  512

#define TVLEN   16
#define LVLEN   16
#define PULEN   16

#include <stdio.h>
#include <io.h>
#include <math.h>
#include <conio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>

//function prototypes
int LoadREF(void);
int ropenTLC(char *);
int wopenTLC(char *);
int Read4Codes(void);
int Read4Hdr(void);
int ReadC(void);
int ReadB(void);
int ReadP(void);
int ReadT(void);
void WriteH(void);
void WriteC(void);
void WriteB(void);
void WriteP(void);
void WriteT(void);
void moveP(void);
void moveB(void);
void moveT(void);
void moveC(void);
void copyP(void);
void copyB(void);
void copyT(void);
void copyC(void);
int abrtCk(void);
char *strclip(char *,uchar);
void Help(void);
void wait(void);
char* GetWildTLC(char *);

//global variables
int OldLayer,NewLayer,Action;

FILE *rTLCfile,*wTLCfile;

//file path
struct ANYFILE{
    char drive[_MAX_DRIVE+1];
    char dir[_MAX_DIR+1];
    char fname[_MAX_FNAME+1];
    char ext[_MAX_EXT+1];
}ref;


//TLC record structs
struct tlchdr
{
    char name[NAMBUF];
    char lv[LVLEN];
    char tv[TVLEN];
    double scale;
    char punit[PULEN];
    char date[10];
    char time[10];
    int rank;
    long l;
    long b;
    long r;
    long t;
    int bn;
    int pn;
    long vn;
    int an;
} TLCh={"",VERS,VERSX,1.,"um",1,0,0,0,0,0,0,0,0};

struct tlccel
{
    char name[NAMBUF];
    int o;
    long x;
    long y;
    int r;
} TLCc;

struct tlcbox
{
    int lyr;
    long l;
    long b;
    long r;
    long t;
} TLCb;

struct tlcpath
{
    int lyr;
    long w;
    int nv;
    long x[VTXMAX];
    long y[VTXMAX];
} TLCp;

struct tlctext
{
    int lyr;
    long siz;
    int nv;
    int o;
    long x;
    long y;
    char text[TLCLIM];
} TLCt;


//*************
//start of main
//*************

main(int argc,char *argv[])
{
    int p=0;
    char *tp;
    static char copybuf[TLCLIM];
    static char refbuf[TLCLIM];
    static char tlcname[NAMBUF];

    printf("\nLASI TLC Layer Mover/Copier  Version 6.1\n\n");

    if(argc<5){
        Help();
        exit(0);
    }
    
    if(!stricmp(argv[1],"m")) Action=1;
    if(!stricmp(argv[1],"c")) Action=2;
     
    if(!Action){
        Help();
        exit(0);
    }
         
    OldLayer=atoi(argv[2]);
    if(OldLayer<1 || OldLayer>256){
        printf("Old Layer out of Range\n");
        wait();
        exit(0);
    }
    
    NewLayer=atoi(argv[3]);
    if(NewLayer<1 || NewLayer>256){
        printf("New Layer out of Range\n");
        wait();
        exit(0);
    }


    //cell loop
    while(strlen(tp=GetWildTLC(argv[4]))){
        strcpy(tlcname,tp);
        strtok(tlcname,".");

        if(!stricmp(tlcname,"TMPTLC"))
             continue;

        printf("%s\n",tlcname);

        if(!ropenTLC(tlcname))
            continue;
        if(!wopenTLC("TMPTLC"))
            continue;

        //get header info
        if(!Read4Hdr()){
            printf("Header Missing in %s\n",tlcname);
            wait();
        }

        //read again for objects
        rewind(rTLCfile);
        Read4Codes();
        fclose(rTLCfile);

    //write header and close
        WriteH();   
        fclose(wTLCfile);

        //copy new file to old
        if(!ropenTLC("TMPTLC"))
            continue;
        if(!wopenTLC(tlcname))
            continue;

        do{
            fgets(copybuf,TLCLIM,rTLCfile);
            if(!feof(rTLCfile))
                fputs(copybuf,wTLCfile);
        }while(!feof(rTLCfile));

        fclose(rTLCfile);
        fclose(wTLCfile);
        
        switch(Action){
        case 1:
            printf("Layer %d Moved to %d in %s.TLC\n",
                    OldLayer,NewLayer,tlcname);
            break;
        case 2:
            printf("Layer %d Copied to %d in %s.TLC\n",
                    OldLayer,NewLayer,tlcname);
        }
        if(abrtCk()) break;
    }
    wait();
    return 0;
}

//******************
//start of functions
//******************

//read TLC header info
int Read4Hdr(void)
{
    static char buf[TLCLIM];
    char *s;

    buf[0]=0;
    while(!feof(rTLCfile)){
        fgets(buf,TLCLIM,rTLCfile);
        if(feof(rTLCfile))   //eof check
            break;

        if(!strcmp(buf,"=H\n")){
            fgets(buf,TLCLIM,rTLCfile);
            strcpy(TLCh.name,strclip(buf,NAMLEN));

            fgets(buf,TLCLIM,rTLCfile);
            strcpy(TLCh.lv,strclip(buf,LVLEN));

            fgets(buf,TLCLIM,rTLCfile);
            strcpy(TLCh.tv,strclip(buf,TVLEN));

            fgets(buf,TLCLIM,rTLCfile);
            TLCh.scale=atof(buf);

            fgets(buf,TLCLIM,rTLCfile);
            strcpy(TLCh.punit,strclip(buf,PULEN));

            fgets(buf,TLCLIM,rTLCfile);
            strcpy(TLCh.date,strclip(buf,8));

            fgets(buf,TLCLIM,rTLCfile);
            strcpy(TLCh.time,strclip(buf,8));

            fgets(buf,TLCLIM,rTLCfile); //outline

            if((s=strtok(buf," "))==NULL) return 0;
            TLCh.rank=atoi(s);

            if((s=strtok(NULL," "))==NULL) return 0;
            TLCh.l=atol(s);
            if((s=strtok(NULL," "))==NULL) return 0;
            TLCh.b=atol(s);
            if((s=strtok(NULL," "))==NULL) return 0;
            TLCh.r=atol(s);
            if((s=strtok(NULL," "))==NULL) return 0;
            TLCh.t=atol(s);

            fgets(buf,TLCLIM,rTLCfile); //counts

            if((s=strtok(buf," "))==NULL) return 0;
            TLCh.bn=atoi(s);

            if((s=strtok(NULL," "))==NULL) return 0;
            TLCh.pn=atoi(s);
            if((s=strtok(NULL," "))==NULL) return 0;
            TLCh.vn=atol(s);
            if((s=strtok(NULL," "))==NULL) return 0;
            TLCh.an=atoi(s);
            return 1;
        }
    }
    return 0;
}

//read for record types then write new records
int Read4Codes(void)
{
    static char buf[TLCLIM];

    buf[0]=0;

    while(!feof(rTLCfile)){
        fgets(buf,TLCLIM,rTLCfile);
        if(feof(rTLCfile))   //eof check
            break;

        if(!strcmp(buf,"=C\n")){
            if(ReadC()){
                switch(Action){
                case 1:
                    moveC();
                    break;
                case 2:
                    copyC();
                }
            }
            else{
                printf("  Cell Record Read Error\n");
                wait();
            }
            continue;
        }
        if(!strcmp(buf,"=B\n")){
            if(ReadB()){
                switch(Action){
                case 1:
                    moveB();
                    break;
                case 2:
                    copyB();
                }
            }
            else{
                printf("  Box Record Read Error\n");
                wait();
            }
            continue;
        }
        if(!strcmp(buf,"=P\n")){
            if(ReadP()){
                switch(Action){
                case 1:
                    moveP();
                    break;
                case 2:
                    copyP();
                }
            }
            else{
                printf("  Path Record Read Error\n");
                wait();
            }
            continue;
        }
        if(!strcmp(buf,"=T\n")){
            if(ReadT()){
                switch(Action){
                case 1:
                    moveT();
                    break;
                case 2:
                    copyT();
                }
            }
            else{
                printf("  Text Record Read Error\n");
                wait();
            }
            continue;
        }
    }
    return 1;
}

//****************
//move operations
//****************

void moveC(void)
{
    WriteC();
}

void moveB(void)
{
    if(TLCb.lyr==OldLayer)
        TLCb.lyr=NewLayer;
    WriteB();
}

void moveT(void)
{
    if(TLCt.lyr==OldLayer)
        TLCt.lyr=NewLayer;
    WriteT();
}

void moveP(void)
{
    if(TLCp.lyr==OldLayer)
        TLCp.lyr=NewLayer;
    WriteP();
}

//****************
//copy operations
//****************

void copyC(void)
{
    WriteC();
}

void copyB(void)
{
    WriteB();
    if(TLCb.lyr==OldLayer)
        TLCb.lyr=NewLayer;
    WriteB();
}

void copyT(void)
{
    WriteT();
    if(TLCt.lyr==OldLayer)
        TLCt.lyr=NewLayer;
    WriteT();
}

void copyP(void)
{
    WriteP();
    if(TLCp.lyr==OldLayer)
        TLCp.lyr=NewLayer;
    WriteP();
}


//************************
//TLC readers and writers
//************************

//read a cell record
int ReadC(void)
{
    static char buf[TLCLIM];
    char *s;

    buf[0]=0;
    if(!feof(rTLCfile)){
        fgets(buf,TLCLIM,rTLCfile);
        strcpy(TLCc.name,strclip(buf,NAMLEN));

        fgets(buf,TLCLIM,rTLCfile);
        strclip(buf,36);

        if((s=strtok(buf," "))==NULL) return 0;
        TLCc.o=atoi(s) & 0x07;

        if((s=strtok(NULL," "))==NULL) return 0;
        TLCc.x=atol(s);

        if((s=strtok(NULL," "))==NULL) return 0;
        TLCc.y=atol(s);
        return 1;
    }
    return 0;
}

//read a box record
int ReadB(void)
{
    static char buf[TLCLIM];
    char *s;

    buf[0]=0;
    if(!feof(rTLCfile)){
        strclip(fgets(buf,TLCLIM,rTLCfile),TLCLIM);

        if((s=strtok(buf," "))==NULL) return 0;
        TLCb.lyr=atoi(s);

        if((s=strtok(NULL," "))==NULL) return 0;
        TLCb.l=atol(s);

        if((s=strtok(NULL," "))==NULL) return 0;
        TLCb.b=atol(s);

        if((s=strtok(NULL," "))==NULL) return 0;
        TLCb.r=atol(s);

        if((s=strtok(NULL," "))==NULL) return 0;
        TLCb.t=atol(s);
        return 1;
    }
    return 0;
}

//read a path record
int ReadP(void)
{
    static char buf[TLCLIM];
    char *s;
    int nv=0,p=0;

    buf[0]=0;
    if(!feof(rTLCfile)){

        strclip(fgets(buf,TLCLIM,rTLCfile),TLCLIM);

        if((s=strtok(buf," "))==NULL) return 0;
        TLCp.lyr=atoi(s);

        if((s=strtok(NULL," "))==NULL) return 0;
        TLCp.w=atol(s);

        if((s=strtok(NULL," "))==NULL) return 0;
        nv=TLCp.nv=atoi(s);

        strclip(fgets(buf,TLCLIM,rTLCfile),TLCLIM);

        if((s=strtok(buf," "))==NULL) return 0;
        TLCp.x[p]=atol(s);  //1st X

        if((s=strtok(NULL," "))==NULL) return 0;
        TLCp.y[p]=atol(s);  //1st Y
        p++;
        nv--;
        while(nv>0){
            if((s=strtok(NULL," "))==NULL){ //end of line read new line
                strclip(fgets(buf,TLCLIM,rTLCfile),TLCLIM);
                if((s=strtok(buf," "))==NULL) return 0;
            }
            TLCp.x[p]=atol(s);  //keep X

            if((s=strtok(NULL," "))==NULL) return 0;
            TLCp.y[p]=atol(s);  //keep Y
            p++;
            nv--;
        }
        return 1;
    }
    return 0;
}

//read a text record
int ReadT(void)
{
    static char buf[TLCLIM];
    char *s;

    buf[0]=0;
    if(!feof(rTLCfile)){
        strclip(fgets(buf,TLCLIM,rTLCfile),TLCLIM);

        if((s=strtok(buf," "))==NULL) return 0;
        TLCt.lyr=atoi(s);

        if((s=strtok(NULL," "))==NULL) return 0;
        TLCt.siz=atol(s);

        if((s=strtok(NULL," "))==NULL) return 0;
        TLCt.nv=atoi(s);

        if((s=strtok(NULL," "))==NULL) return 0;
        TLCt.o=atoi(s);

        //coords
        strclip(fgets(buf,TLCLIM,rTLCfile),TLCLIM);

        if((s=strtok(buf," "))==NULL) return 0;
        TLCt.x=atol(s);

        if((s=strtok(NULL," "))==NULL) return 0;
        TLCt.y=atol(s);

        //text string
        strclip(fgets(buf,TLCLIM,rTLCfile),TLCLIM);
        strcpy(TLCt.text,buf);
        return 1;
    }
    return 0;
}

//write TLC header info
void WriteH(void)
{
    static char buf[16];

    fprintf(wTLCfile,"=H\n");
    fprintf(wTLCfile,"%s\n",TLCh.name);
    fprintf(wTLCfile,"%s\n",VERS);
    fprintf(wTLCfile,"%s\n",VERSX);
    fprintf(wTLCfile,"%g\n",TLCh.scale);
    fprintf(wTLCfile,"%s\n",TLCh.punit);
    fprintf(wTLCfile,"%s\n",_strdate(buf));
    fprintf(wTLCfile,"%s\n",_strtime(buf));
    fprintf(wTLCfile,"%d %ld %ld %ld %ld\n",TLCh.rank,TLCh.l,TLCh.b,TLCh.r,TLCh.t);
    fprintf(wTLCfile,"%d %d %ld %d\n",TLCh.bn,TLCh.pn,TLCh.vn,TLCh.an);
}

//write a cell record
void WriteC(void)
{
    TLCh.an++;
    fprintf(wTLCfile,"=C\n");
    fprintf(wTLCfile,"%s\n",TLCc.name);
    fprintf(wTLCfile,"%d %ld %ld %d\n",TLCc.o,TLCc.x,TLCc.y,0);
}

//write a box record
void WriteB(void)
{
    TLCh.bn++;
    fprintf(wTLCfile,"=B\n");
    fprintf(wTLCfile,"%d %ld %ld %ld %ld\n",TLCb.lyr,TLCb.l,TLCb.b,TLCb.r,TLCb.t);
}

//write a path record
void WriteP(void)
{
    int n=0;    //coords start at 0

    TLCh.pn++;
    TLCh.vn+=TLCp.nv;
    fprintf(wTLCfile,"=P\n");
    fprintf(wTLCfile,"%d %ld %d\n",TLCp.lyr,TLCp.w,TLCp.nv);

    //write 5 vertex/line
    while(n<TLCp.nv){
        fprintf(wTLCfile,"%ld %ld ",TLCp.x[n],TLCp.y[n]);
        n++;
        if(!(n % 5)) fprintf(wTLCfile,"\n");
    }
    if((n % 5)) fprintf(wTLCfile,"\n");
}

//write a text record
void WriteT(void)
{
    int n=3;

    TLCh.pn++;
    TLCh.vn+=TLCt.nv;
    fprintf(wTLCfile,"=T\n");
    fprintf(wTLCfile,"%d %ld %d %d\n",TLCt.lyr,TLCt.siz,TLCt.nv,TLCt.o);
    fprintf(wTLCfile,"%ld %ld\n",TLCt.x,TLCt.y);

#if defined (SPACE_T)
    //tag strings
    if(!strcmp("=H",TLCt.text) ||
        !strcmp("=C",TLCt.text) ||
        !strcmp("=B",TLCt.text) ||
        !strcmp("=P",TLCt.text) ||
        !strcmp("=T",TLCt.text)){
        while(n-- >0) TLCt.text[n+1]=TLCt.text[n];
        TLCt.text[0]=' ';
    }
#endif
    fprintf(wTLCfile,"%s\n",TLCt.text);
}

//****************
//misc. functions
//****************

//open any TLC for read
int ropenTLC(char *name)
{
    static char namebuf[NAMLEN+5];

    sprintf(namebuf,"%s.TLC",name);

    if((rTLCfile=fopen(namebuf,"rt"))==NULL)
        return 0;
    return 1;
}

//open any TLC for write
int wopenTLC(char *name)
{
    static char namebuf[NAMLEN+5];

    sprintf(namebuf,"%s.TLC",name);
    if((wTLCfile=fopen(namebuf,"wt"))==NULL)
        return 0;
    return 1;
}


//remove nl or limit to c-1 char
char *strclip(char *s,uchar c)
{
    uchar l;

    if(s==NULL) return s;
    if(strlen(s)==0) return s;
    if(c==0) return s;

    l=strlen(s);
    if(s[l-1]=='\n')    //ends with nl
        s[l-1]=0;       //remove '\n'
    s[c-1]=0;           //limit to c-1 chars
    return s;           //return pointer
}

//check for key abort
int abrtCk(void)
{
    int key=0;

    if(kbhit()){
        key=getch();
        if(key==0x1B) return 1;
        if(key==0 || key==0xE0) getch();
        return 0;
    }
    return 0;
}

char* GetWildTLC(char *wildname)
{
    static struct _finddata_t ff;
    static long hf=0,ncells=0;
    static char buf[_MAX_PATH];
    int success=0;

    ff.name[0]=0;
    sprintf(buf,"%s.tlc",wildname);

    if(hf==-1) return "";

    if(!hf){
        if(success=(hf=_findfirst(buf,&ff))!=-1)
        return ff.name;
    }

    success=((_findnext(hf,&ff)!=-1) && ncells++<CELMAX);

    if(!success)
        _findclose(hf);

    return ff.name;
}

void Help(void)
{
printf("\
This program moves or copies the layers of boxes, poly and text in TLC files.\n\
It reads files according to the wildcard (* ?) cellname on the command line.\n\n\
   Command line :  mclayer m[c] oldlayer newlayer cellname\n\n");
    wait();
}

void wait(void)
{
    printf("\nPress a key to continue...\n");
    getch();
}